unit UnitMain;

interface

uses
  Windows, Classes, Controls, Forms, Menus,
  uFrmPuppyReader,uCtxPuppyReader, TrayIcons;
var
  AppRun: Boolean = True;

type
  TFormClass = class of TFrmPuppyReader;

procedure FormShow( FormClass: TFormClass;Context:TCtxPuppyReader; Reference:TfrmPuppyReader );

implementation



procedure FormShow( FormClass: TFormClass;Context:TCtxPuppyReader; Reference:TfrmPuppyReader );
begin
  if TForm( Reference ) = nil then TForm( Reference ) := FormClass.Create( nil,Context );
  TForm( Reference ).Show;
end;

type
  TMyTrayIcon = class( TTrayIcon )
  private
  	m_ctxPuppyReader : TCtxPuppyReader;
    FMenu: TPopupMenu;
    procedure CreateMenuItem( ACaption: String; Event: TNotifyEvent );
    procedure MouseDown( Sender: TObject; Button: TMouseButton );
    procedure MenuOpenClick( Sender: TObject );
    procedure MenuExitClick( Sender: TObject );
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

var
  TrayIcon: TTrayIcon;

{ TMyTrayIcon }

constructor TMyTrayIcon.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FMenu := TPopupMenu.Create( nil );
  FMenu.AutoHotkeys := maManual;

  CreateMenuItem( '', MenuOpenClick );
  CreateMenuItem( '', MenuExitClick );

 	m_ctxPuppyReader := TCtxPuppyReader.Create(AOwner);
  OnMouseDown := MouseDown;

  FormShow( TfrmPuppyReader,m_ctxPuppyReader,frmPuppyReader );
end;

procedure TMyTrayIcon.CreateMenuItem(ACaption: String; Event: TNotifyEvent);
var
  MenuItem: TMenuItem;
begin
  MenuItem := TMenuItem.Create( nil );
  MenuItem.Caption := ACaption;
  MenuItem.OnClick := Event;
  FMenu.Items.Add( MenuItem );
end;

destructor TMyTrayIcon.Destroy;
begin
 	m_ctxPuppyReader.Destroy;
  FMenu.Free;
  inherited Destroy;
end;

procedure TMyTrayIcon.MenuOpenClick(Sender: TObject);
begin
  FormShow( TfrmPuppyReader,m_ctxPuppyReader,frmPuppyReader );
end;

procedure TMyTrayIcon.MenuExitClick(Sender: TObject);
begin
  AppRun := False;
end;

procedure TMyTrayIcon.MouseDown(Sender: TObject; Button: TMouseButton);
begin
  FMenu.Popup( Mouse.CursorPos.X, Mouse.CursorPos.Y );
end;

initialization
  TrayIcon := TMyTrayIcon.Create( Application );
  TrayIcon.Hint := 'PuppyReader';
  TrayIcon.Icon := Application.Icon;


finalization
  TrayIcon.Free;

end.





