unit uFrmPuppyReader;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, StdCtrls, HTTPApp, ScktComp, xmldom, XMLIntf,
  msxmldom, XMLDoc, ComCtrls,StrUtils, ImgList, Buttons, ExtCtrls,
  oxmldom, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, Menus,uCtxPuppyReader;


type
  TfrmPuppyReader = class(TForm)
    m_imgsItem: TImageList;
    pnlRight: TPanel;
    pnlLeft: TPanel;
    Splitter1: TSplitter;
    trCategory: TTreeView;
    mnuMain: TMainMenu;
    File1: TMenuItem;
    ool1: TMenuItem;
    Help1: TMenuItem;
    pnlTop: TPanel;
    m_lbUrl: TLabel;
    m_cbUrl: TComboBox;
    m_sbGo: TSpeedButton;
    Button1: TButton;
    pnBottom: TPanel;
    wbOutput: TWebBrowser;
    pnMidTop: TPanel;
    Splitter2: TSplitter;
    m_lstItemView: TListView;
    m_btnSubscribe: TButton;
    m_imgsTree: TImageList;
    m_tmBuildXmlTreeChecker: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure m_lstItemViewClick(Sender: TObject);
    procedure m_sbGoClick(Sender: TObject);
    procedure m_cbUrlKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure m_lstItemViewDrawItem(Sender: TCustomListView;
      Item: TListItem; Rect: TRect; State: TOwnerDrawState);
    procedure m_btnSubscribeClick(Sender: TObject);
    procedure trCategoryClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
 		procedure AppOnException(Sender:TObject; E:Exception);
    procedure AddListViewItems(pSite :PTRSSSite);
    procedure UpdateSitesList;
    procedure m_tmBuildXmlTreeCheckerTimer(Sender: TObject);
	public
    constructor Create(AOwner:TComponent; ctx: TCtxPuppyReader);
  private
   	m_frmContext : TCtxPuppyReader;
    m_pSelectedSite : PTRSSSite;
    //Netκ    Ȯ
    m_bDataFromNetCompleted : Boolean;
    //Localκ    Ȯ
    m_bDataFromLocalCompleted : Boolean;
    { Private declarations }
    procedure vStartNavigation;

end;
var
	frmPuppyReader: TfrmPuppyReader;

implementation

{$R *.dfm}

constructor TfrmPuppyReader.Create(AOwner:TComponent; ctx: TCtxPuppyReader);
begin
	inherited Create(AOwner);

  m_frmContext := ctx;
  UpdateSitesList;
  m_bDataFromNetCompleted := False;
  m_bDataFromLocalCompleted := False;

end;

procedure TfrmPuppyReader.AppOnException(Sender:TObject; E:Exception);
begin
  Application.MessageBox(PChar(E.Message),'˸',mb_ok+mb_IconInformation);
end;

procedure TfrmPuppyReader.FormCreate(Sender: TObject);
begin
  Application.OnException := AppOnException;
  //  Ʈ 信 ǥõ  Ͻ ϴ Ʈ
  // Ʈ信 ǥõ  ϴ Ʈ
//TODO0803  m_lstSites := TList.Create;

//TODO0803  m_pSelectedSite := nil;
	wbOutput.Navigate('About:Blank');
end;


procedure TfrmPuppyReader.UpdateSitesList;
var
	lstSite : TList;
  idx : Integer;
  node : TTreeNode;
  pRSSSite : PTRSSSite;
begin
 	lstSite := m_frmContext.rGetSiteLists;
  for idx := 0 to lstSite.Count -1 do
  begin
  	pRssSite := PTRSSSite(lstSite.Items[idx]);
		node := trCategory.Items.AddChildObjectFirst(trCategory.TopItem,pRssSite.title,pRSSSite);
  	node.ImageIndex := 1;
  	node.SelectedIndex := 1;
	end;
 	trCategory.TopItem.Expanded := true;

end;



procedure TfrmPuppyReader.AddListViewItems(pSite : PTRSSSite);
var
	lstItem : TListItem;
  iIdx : Integer;
begin
	m_lstItemView.Items.Clear;

	for iIdx := 0 to pSite.itemList.Count-1 do
  begin
		lstItem := m_lstItemView.Items.Add;
	  lstItem.Caption := PTRSSItem(pSite.itemList.Items[iIdx]).strTitle;
    lstItem.SubItems.Add(PTRSSItem(pSite.itemList.Items[iIdx]).strPubDate);
		lstItem.SubItems.Add(PTRSSItem(pSite.itemList.Items[iIdx]).strSubject);
  end;

end;



{ DONE :  description ϵ ϱ. }
procedure TfrmPuppyReader.m_lstItemViewClick(Sender: TObject);
var
	pCurrentSite:PTRSSSite;
  lstItems:TList;
begin
	if m_lstItemView.Selected = nil then
  begin
  	exit;
  end
  else if m_lstItemView.Selected.Index > m_lstItemView.Items.Count then
  begin
  	exit;
  end;

	pCurrentSite := m_frmContext.pGetCurrentSite;
  lstItems := pCurrentSite.itemList;
	if StrLen( PChar( PTRSSItem(lstItems.Items[m_lstItemView.Selected.Index]).strDescription ) ) > 0 then
  begin
		wbOutput.OleObject.Document.Body.innerHTML := PTRSSItem(lstItems.Items[m_lstItemView.Selected.Index]).strDescription;
  end
  else
  begin
		wbOutput.Navigate( PTRSSItem(lstItems.Items[m_lstItemView.Selected.Index]).strLink );
  end;
  wbOutput.OleObject.Document.Body.Doscroll('PageUp');

end;

procedure TFrmPuppyReader.vStartNavigation;
begin
  m_bDataFromNetCompleted := False;
  m_bDataFromLocalCompleted := False;
  wbOutput.Navigate('About:Blank');
  m_frmContext.vStartNavigation(m_cbUrl.Text);

  m_tmBuildXmlTreeChecker.Enabled := True;

end;


procedure TfrmPuppyReader.m_sbGoClick(Sender: TObject);
begin
		vStartNavigation;
end;

procedure TfrmPuppyReader.m_cbUrlKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	if Key = 13 then
  begin
		vStartNavigation;
  end;

end;



procedure TfrmPuppyReader.m_lstItemViewDrawItem(Sender: TCustomListView;
  Item: TListItem; Rect: TRect; State: TOwnerDrawState);
begin
with m_lstItemView	do begin
  SetBKMode(m_lstItemView.Canvas.Handle, Transparent);
  Canvas.Font.Color := clBlack;
	Canvas.FillRect(Rect);

  Canvas.TextOut(1+Rect.Left, Rect.Top, Item.Caption);
	Canvas.TextOut(1+Rect.Left+ m_lstItemView.Columns[0].Width , Rect.Top, Item.SubItems.Strings[0]);
	Canvas.TextOut(1+Rect.Left+ m_lstItemView.Columns[0].Width + m_lstItemView.Columns[1].Width , Rect.Top, Item.SubItems.Strings[1]);
	Canvas.TextOut(1+Rect.Left+ m_lstItemView.Columns[0].Width + m_lstItemView.Columns[1].Width + m_lstItemView.Columns[2].Width , Rect.Top, Item.SubItems.Strings[2]);
end;
end;


procedure TfrmPuppyReader.m_btnSubscribeClick(Sender: TObject);
var
	node : TTreeNode;
  pItem : PTRSSSite;
begin
	if m_frmContext.strGetCurrentRssUrl = '' then
  begin
  	exit;
  end
  else if m_frmContext.bExistSite(m_frmContext.stGetCurrentSite.rssurl) = true then
  begin
  	exit;
  end;

	pItem := m_frmContext.pAddCurrentSite;
	m_pSelectedSite := pItem;
	node := trCategory.Items.AddChildObjectFirst(trCategory.TopItem,pItem.title,pItem);
  node.ImageIndex := 1;
  node.SelectedIndex := 1;
  trCategory.TopItem.Expanded := true;
end;

procedure TfrmPuppyReader.trCategoryClick(Sender: TObject);
begin
	if not(trCategory.Selected.Data = nil) and
  	 not(trCategory.Selected.Data = m_pSelectedSite) then
	begin
  	m_pSelectedSite := trCategory.Selected.Data;
    m_frmContext.vStartNavigation(PTRSSSite(trCategory.Selected.Data).rssurl);
    m_tmBuildXmlTreeChecker.Enabled := True;
  end;
end;

procedure TfrmPuppyReader.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
	Action := caFree;
	frmPuppyReader := nil;
end;

procedure TfrmPuppyReader.FormDestroy(Sender: TObject);
begin
	wbOutput.Free;
end;


procedure TfrmPuppyReader.m_tmBuildXmlTreeCheckerTimer(Sender: TObject);
var
	pSite : PTRSSSite;
begin
	if m_frmContext.bBuildXmlListFromNetCompleted = true  and
  	self.m_bDataFromNetCompleted = False then
  begin
  	self.m_bDataFromNetCompleted := True;
    pSite := m_frmContext.pGetCurrentSite;
		AddListViewItems(pSite);
  end;

  if m_frmContext.bBuildXmlListFromLocalCompleted = true and
  	self.m_bDataFromLocalCompleted = FALSE then
  begin
  	self.m_bDataFromLocalCompleted := True;
    pSite := m_frmContext.pGetCurrentSite;
		AddListViewItems(pSite);
	end;

  if m_bDataFromLocalCompleted = true and
  	m_bDataFromNetCompleted = true then
  begin
    m_tmBuildXmlTreeChecker.Enabled := False;
    m_bDataFromLocalCompleted := False;
    m_bDataFromNetCompleted := False;
  end;
end;

end.


